Page MenuHomeFreeBSD

Simplify handling of superpages in pmap_clear_modify()
ClosedPublic

Authored by alc on Jul 22 2019, 3:19 PM.

Details

Summary

If a demotion succeeds, then all of the 4KB page mappings within the superpage-sized region must be valid, so there is no point in testing the validity of the 4KB page mapping that is going to be write protected.

Deindent the code.

Diff Detail

Repository
rS FreeBSD src repository
Lint
Automatic diff as part of commit; lint not applicable.
Unit
Automatic diff as part of commit; unit tests not applicable.

Event Timeline

alc created this revision.Jul 22 2019, 3:19 PM
alc added a comment.Jul 22 2019, 3:22 PM

Peter, could you please test this patch on amd64 and i386.

pho added a comment.Jul 22 2019, 3:23 PM

Sure, happy to.

pho added a comment.Jul 24 2019, 1:58 PM

I finished the full stress2 tests on amd64 without any issues.

On i386 I ran into this problem, which seems unrelated to me. Unfortunately I did not get a dump as the debugger was looping.
I made a short attempt to recreate the problem, but without any luck.
Here's the partial console log: https://people.freebsd.org/~pho/stress/log/alc010.txt
I still need to run 170 tests on i386 to complete a full test.

alc added a comment.Jul 24 2019, 2:55 PM
In D21027#456866, @pho wrote:

I finished the full stress2 tests on amd64 without any issues.

Thank you.

On i386 I ran into this problem, which seems unrelated to me. Unfortunately I did not get a dump as the debugger was looping.
I made a short attempt to recreate the problem, but without any luck.
Here's the partial console log: https://people.freebsd.org/~pho/stress/log/alc010.txt
I still need to run 170 tests on i386 to complete a full test.

I agree that that problem seems unrelated.

pho added a comment.Jul 25 2019, 4:10 AM

The i386 tests finished with one further problem and an incomplete report: https://people.freebsd.org/~pho/stress/log/alc011.txt

alc added a comment.Jul 25 2019, 4:57 AM
In D21027#457081, @pho wrote:

The i386 tests finished with one further problem and an incomplete report: https://people.freebsd.org/~pho/stress/log/alc011.txt

That also seems unrelated. Thanks.

alc added reviewers: kib, markj.Jul 25 2019, 4:57 AM
kib accepted this revision.Jul 25 2019, 7:26 AM
This revision is now accepted and ready to land.Jul 25 2019, 7:26 AM
markj accepted this revision.Jul 25 2019, 3:30 PM